/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.tutorial.uc0001;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import jp.terasoluna.fw.batch.openapi.JobContext;


/**
 * ビジネスロジック、ジョブ前処理・ジョブ後処理で共有されるクラス。
 */
public class JB0002JobContext extends JobContext {

    /**
     * Serializable用バージョンID。
     */
    private static final long serialVersionUID = -3997908200329994279L;

    /**
     * 運用日付
     */
    private Date unyohiduke = null;
 
    /**
     * 処理件数のカウント
     */
    private int count = 0;
    
    /**
     * 起動時の引数をジョブコンテキストに設定する。
     *
     * @param arg 起動時に指定した第3引数以降の値
     */
    @Override
    public void setParameter(String[] arg) {
        try {
            //起動パラメータから運用日付を取得する
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            unyohiduke = sdf.parse(arg[0]);
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

    /**
     * 運用日付を返却する。
     * @return 運用日付
     */
    public Date getUnyohiduke() {
        return unyohiduke;
    }

    /**
     * 運用日付を設定する。
     * @param unyohiduke 運用日付
     */
    public void setUnyohiduke(Date unyohiduke) {
        this.unyohiduke = unyohiduke;
    }

    /**
     * 処理件数をカウントアップする。
     */
    public void incrementCount() {
        count++;
    }
    
    /**
     * 処理件数を返却する。
     * @return 処理件数。
     */
    public int getCount() {
        return count;
    }

}
